#include <GUIConstantsEx.au3>
#include <GDIPlus.au3>
#include <GuiStatusBar.au3>


Func _DessineLabyrinthe($hGraphic = $hGraphicImage)
	Local $hBrushFond, $hPenMurs, $hPenContours
	$hBrushFond = _GDIPlus_BrushCreateSolid($hexCouleurFond)
	$hPenMurs = _GDIPlus_PenCreate($hexCouleurMur, $iEpaisseurMur)
	$hPenContours = _GDIPlus_PenCreate($hexCouleurContour, $iEpaisseurContour)
	_CreeFond($hBrushFond, $hGraphic)
	_AfficheMursHorizontaux($aPosition[2], Floor($iEpaisseurMur / 2), $hPenMurs, $hGraphic)
	_AfficheMursVerticaux($aPosition[2], Floor($iEpaisseurMur / 2), $hPenMurs, $hGraphic)
	_AfficheContours($aPosition[2], Floor($iEpaisseurContour / 2), $hPenContours, $hGraphic)
	_AfficheObjets($aPosition[2], $iTailleCellule - $iEpaisseurMur - 2, $hGraphic)
	If $hGraphic = $hGraphicImage And $iEtages > 1 Then _AfficheEtage()
	_GDIPlus_BrushDispose($hBrushFond)
	_GDIPlus_PenDispose($hPenMurs)
	_GDIPlus_PenDispose($hPenContours)
EndFunc   ;==>_DessineLabyrinthe


; Cre une image blanche
Func _CreeImage($width, $height, ByRef $hImage, ByRef $hGraphicImage, $couleur = 0xFFFFFFFF)
	Local $hBitmap
	$hBitmap = _WinAPI_CreateBitmap($width, $height, 1, 32)
	$hImage = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	_WinAPI_DeleteObject($hBitmap)
	$hGraphicImage = _GDIPlus_ImageGetGraphicsContext($hImage)
	_GDIPlus_GraphicsClear($hGraphicImage, $couleur)
EndFunc   ;==>_CreeImage


Func _ChargePersonnage()
	Local $iDimensions, $hImage, $hImageTmp, $hGraphicImage
	$iDimensions = $iTailleCellule - $iEpaisseurMur - 2
	$hImageTmp = _GDIPlus_ImageLoadFromFile($pPerso) ; correspond au personnage
	_CreeImage($iDimensions, $iDimensions, $hImage, $hGraphicImage, $hexCouleurFond)
	_GDIPlus_GraphicsDrawImageRect($hGraphicImage, $hImageTmp, 0, 0, $iDimensions, $iDimensions)
	
	_GDIPlus_GraphicsDispose($hGraphicImage)
	_GDIPlus_ImageDispose($hImageTmp)
	
	Return $hImage
EndFunc   ;==>_ChargePersonnage


Func _AfficheImage($hWnd = $gui, $Msg = "", $wParam = "", $lParam = "")
	Switch $hWnd
		Case $gui
			_GDIPlus_GraphicsDrawImage($hGraphicWnd, $hImage, 0, 0) ; labyrinthe
			_GDIPlus_GraphicsDrawImage($hGraphicWnd, $hPerso, ($aPosition[0] + 1) * $iTailleCellule + 2, ($aPosition[1] + 1) * $iTailleCellule + 2) ; personnage
		Case $gui_attente
			_GDIPlus_GraphicsDrawImage($hGraphicWndAttente, $hImageAttente, 0, 0)
		Case $gui_skin
			_GDIPlus_GraphicsDrawImage($hGraphicWndSkin, $hImageApercu, 260, 20)
			_GDIPlus_GraphicsDrawImage($hGraphicWndSkin, $hPersoApercu, ($aPosition[0] + 1) * $iTailleCellule + 262, ($aPosition[1] + 1) * $iTailleCellule + 22) ; personnage
	EndSwitch
	Return $GUI_RUNDEFMSG ; Return RUNDEF, so that the internal PAINT is called, too
EndFunc   ;==>_AfficheImage


#Region DEPLACEMENTS
Func _ActiveRaccourcis()
	HotKeySet("{DOWN}", "_Down")
	HotKeySet("{UP}", "_Up")
	HotKeySet("{RIGHT}", "_Right")
	HotKeySet("{LEFT}", "_Left")
	HotKeySet("{ENTER}", "_Enter")
EndFunc   ;==>_ActiveRaccourcis


Func _DesactiveRaccourcis()
	HotKeySet("{DOWN}")
	HotKeySet("{UP}")
	HotKeySet("{RIGHT}")
	HotKeySet("{LEFT}")
	HotKeySet("{ENTER}")
EndFunc   ;==>_DesactiveRaccourcis


Func _Down()
	If $aPosition[1] < UBound($aMursHorizontaux, 2) And $aMursHorizontaux[$aPosition[0]][$aPosition[1]][$aPosition[2]] = 0 Then
		$aPosition[1] += 1
		_AfficheImage()
	ElseIf $aSortie[0] = 4 And $aPosition[0] + 1 = $aSortie[1] And $aPosition[1] = UBound($aMursHorizontaux, 2) Then
		$iVictoire = 1
	EndIf
EndFunc   ;==>_Down


Func _Up()
	If $aPosition[1] > 0 And $aMursHorizontaux[$aPosition[0]][$aPosition[1] - 1][$aPosition[2]] = 0 Then
		$aPosition[1] -= 1
		_AfficheImage()
	ElseIf $aSortie[0] = 1 And $aPosition[0] + 1 = $aSortie[1] And $aPosition[1] = 0 Then
		$iVictoire = 1
	EndIf
EndFunc   ;==>_Up


Func _Right()
	If $aPosition[0] < UBound($aMursVerticaux) And $aMursVerticaux[$aPosition[0]][$aPosition[1]][$aPosition[2]] = 0 Then
		$aPosition[0] += 1
		_AfficheImage()
	ElseIf $aSortie[0] = 3 And $aPosition[1] + 1 = $aSortie[1] And $aPosition[0] = UBound($aMursVerticaux) Then
		$iVictoire = 1
	EndIf
EndFunc   ;==>_Right


Func _Left()
	If $aPosition[0] > 0 And $aMursVerticaux[$aPosition[0] - 1][$aPosition[1]][$aPosition[2]] = 0 Then
		$aPosition[0] -= 1
		_AfficheImage()
	ElseIf $aSortie[0] = 2 And $aPosition[1] + 1 = $aSortie[1] And $aPosition[0] = 0 Then
		$iVictoire = 1
	EndIf
EndFunc   ;==>_Left


Func _Enter()
	Local $i
	
	For $i = 0 To UBound($aObjets) - 1
		If $aObjets[$i][1] = $aPosition[0] And $aObjets[$i][2] = $aPosition[1] And $aObjets[$i][3] = $aPosition[2] Then
			Switch $aObjets[$i][0]
				Case "D"
					$aPosition[2] -= 1
				Case "M"
					$aPosition[2] += 1
			EndSwitch
			_GDIPlus_GraphicsClear($hGraphicImage, 0xFFFFFFFF)
			_DessineLabyrinthe()
			_AfficheImage()
			Return
		EndIf
	Next
EndFunc   ;==>_Enter
#EndRegion DEPLACEMENTS


#Region DESSINS
; Cre le fond du labyrinthe
Func _CreeFond($hBrushFond, $hGraphic = $hGraphicImage)
	_GDIPlus_GraphicsFillRect($hGraphic, $iTailleCellule, $iTailleCellule, $iLargeur * $iTailleCellule, $iHauteur * $iTailleCellule, $hBrushFond)
EndFunc   ;==>_CreeFond


Func _AfficheEtage()
	Local $hBrush, $hFormat, $hFamily, $hFont, $tLayout, $aInfo, $sString
	
	$sString = "Etage " & $aPosition[2] + 1
	
	$hBrush = _GDIPlus_BrushCreateSolid($hexCouleurPolice)
	$hFamily = _GDIPlus_FontFamilyCreate($sPolice)
	$hFont = _GDIPlus_FontCreate($hFamily, $iTailleCellule * 1.5, 3, 2)
	$hLayout = _GDIPlus_RectFCreate(0, ($iHauteur + 1.1) * $iTailleCellule, ($iLargeur + 2) * $iTailleCellule, $iTailleCellule * 2)
	$hStringFormat = _GDIPlus_StringFormatCreate()
	_GDIPlus_StringFormatSetAlign($hStringFormat, 1)
	_GDIPlus_GraphicsDrawStringEx($hGraphicImage, $sString, $hFont, $hLayout, $hStringFormat, $hBrush)

	; Clean up resources
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hStringFormat)
	_GDIPlus_BrushDispose($hBrush)
EndFunc   ;==>_AfficheEtage


Func _AfficheObjets($iEtage, $iDimensions, $hGraphic = $hGraphicImage)
	Local $i, $hImageTmp
	
	For $i = 0 To UBound($aObjets) - 1
		If $aObjets[$i][3] = $iEtage Then
			Switch $aObjets[$i][0]
				Case "D"
					$hImageTmp = _GDIPlus_ImageLoadFromFile($pEscDescente)
				Case "M"
					$hImageTmp = _GDIPlus_ImageLoadFromFile($pEscMontee)
			EndSwitch
			_GDIPlus_GraphicsDrawImageRect($hGraphic, $hImageTmp, ($aObjets[$i][1] + 1) * $iTailleCellule + 2, ($aObjets[$i][2] + 1) * $iTailleCellule + 2, $iDimensions, $iDimensions)
			_GDIPlus_ImageDispose($hImageTmp)
		EndIf
	Next
EndFunc   ;==>_AfficheObjets


Func _AfficheMursHorizontaux($iEtage, $iCorrection, $hPenMurs, $hGraphic = $hGraphicImage)
	Local $iX, $iY
	
	For $iX = 1 To $iLargeur
		For $iY = 2 To $iHauteur
			If $aMursHorizontaux[$iX - 1][$iY - 2][$iEtage] = 1 Then _GDIPlus_GraphicsDrawLine($hGraphic, $iX * $iTailleCellule - $iCorrection, $iY * $iTailleCellule, ($iX + 1) * $iTailleCellule + $iCorrection, $iY * $iTailleCellule, $hPenMurs)
		Next
	Next
EndFunc   ;==>_AfficheMursHorizontaux


Func _AfficheMursVerticaux($iEtage, $iCorrection, $hPenMurs, $hGraphic = $hGraphicImage)
	Local $iX, $iY
	
	For $iX = 2 To $iLargeur
		For $iY = 1 To $iHauteur
			If $aMursVerticaux[$iX - 2][$iY - 1][$iEtage] = 1 Then _GDIPlus_GraphicsDrawLine($hGraphic, $iX * $iTailleCellule, $iY * $iTailleCellule - $iCorrection, $iX * $iTailleCellule, ($iY + 1) * $iTailleCellule + $iCorrection, $hPenMurs)
		Next
	Next
EndFunc   ;==>_AfficheMursVerticaux


Func _AfficheContours($iEtage, $iCorrection, $hPenContours, $hGraphic = $hGraphicImage)
	Local $i, $e1 = $aEntree[0], $e2 = $aEntree[1], $s1 = $aSortie[0], $s2 = $aSortie[1]
	
	For $i = 1 To $iLargeur ; contours horizontaux
		If _VerifieEntSort($i, 1, $iEtage) Then _GDIPlus_GraphicsDrawLine($hGraphic, $i * $iTailleCellule - $iCorrection, $iTailleCellule, ($i + 1) * $iTailleCellule + $iCorrection, $iTailleCellule, $hPenContours)
		If _VerifieEntSort($i, 4, $iEtage) Then _GDIPlus_GraphicsDrawLine($hGraphic, $i * $iTailleCellule - $iCorrection, ($iHauteur + 1) * $iTailleCellule, ($i + 1) * $iTailleCellule + $iCorrection, ($iHauteur + 1) * $iTailleCellule, $hPenContours)
	Next
	
	For $i = 1 To $iHauteur ; contours verticaux
		If _VerifieEntSort($i, 2, $iEtage) Then _GDIPlus_GraphicsDrawLine($hGraphic, $iTailleCellule, $i * $iTailleCellule - $iCorrection, $iTailleCellule, ($i + 1) * $iTailleCellule + $iCorrection, $hPenContours)
		If _VerifieEntSort($i, 3, $iEtage) Then _GDIPlus_GraphicsDrawLine($hGraphic, ($iLargeur + 1) * $iTailleCellule, $i * $iTailleCellule - $iCorrection, ($iLargeur + 1) * $iTailleCellule, ($i + 1) * $iTailleCellule + $iCorrection, $hPenContours)
	Next
EndFunc   ;==>_AfficheContours


Func _VerifieEntSort($i, $iCote, $iEtage)
	If ($aEntree[0] = $iCote And $aEntree[1] = $i And $iEtage = $iEtages - 1) Or ($aSortie[0] = $iCote And $aSortie[1] = $i And $iEtage = 0) Then Return 0
	Return 1
EndFunc   ;==>_VerifieEntSort
#EndRegion DESSINS