#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiStatusBar.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <File.au3>
#include <Math.au3>

Global $iLargeur, $iHauteur, $iEtages, $iEscaliers, $aMursHorizontaux, $aMursVerticaux, $aObjets, $aEntree, $aSortie, $aCoordEntree, $aCoordSortie, $skin, $iTempsCreation
Global $iTailleCellule, $hexCouleurMur, $iEpaisseurMur, $hexCouleurContour, $iEpaisseurContour, $hexCouleurFond, $sPolice, $hexCouleurPolice, $pPerso, $pEscMontee, $pEscDescente
Global $aPosition, $hGraphicWnd, $hImage, $hGraphicImage, $hPerso, $iVictoire = 0, $iDebut
Global $aSolution
Global $tiQuitter, $tiNouveau, $tiCharger, $tiEnregistrer, $tiSkin
Global $gui, $mJeu, $miNouveau, $miCharger, $miEnregistrer, $miScores, $mOptions, $miSkin, $hStatusBar, $sStatusBarText = ""
Global $gui_attente, $hImageAttente, $hGraphicAttente, $hGraphicWndAttente
Global $gui_skin, $hImageApercu, $hGraphicApercu, $hGraphicWndSkin, $hPersoApercu
Global $gui_score

#include <Generation3D.au3>
#include <Affichage3D.au3>
#include <Skin.au3>
#include <Parametres.au3>

Opt("OnExitFunc", "ExitFunc")
_ConstruitTray()

$iLargeur = 10
$iHauteur = 10
$iEtages = 2
$iEscaliers = 5
Dim $aPosition[3]
$skin = "brique"
_ChargeParametres()

_GDIPlus_Startup()

_ConstruitGUIAttente()

$hPerso = _ChargePersonnage()
GUIRegisterMsg(0xF, "_AfficheImage") ; Sert  r-afficher l'image si l'on minimize puis restaure la fentre
If _Nouveau() = 0 Then Exit
_ActiveRaccourcis()

Local $iWinActive = 1, $iOldTempsEcoule = -1, $iTempsEcoule

While 1
	$msg = GUIGetMsg()
	$msg_tray = TrayGetMsg()
	$iTempsEcoule = Round(TimerDiff($iDebut) / 1000)
	
	Select
		Case $msg = $GUI_EVENT_CLOSE Or $msg_tray = $tiQuitter
			ExitLoop
		Case WinActive($gui) = 0 And $iWinActive = 1
			_DesactiveRaccourcis()
			$iWinActive = 0
		Case WinActive($gui) = 1 And $iWinActive = 0
			_ActiveRaccourcis()
			$iWinActive = 1
		Case $msg = $miNouveau Or $msg_tray = $tiNouveau
			_Nouveau()
		Case $msg = $miEnregistrer Or $msg_tray = $tiEnregistrer
			_EnregistreLabyrinthe()
		Case $msg = $miCharger Or $msg_tray = $tiCharger
			_Charger()
		Case $msg = $miSkin Or $msg_tray = $tiSkin
			_ChangerSkin()
		Case $msg = $miScores
			_VoirMeilleursScores()
		Case $iVictoire = 1
			If _MeilleurScore() = 0 Then ExitLoop
		Case $iOldTempsEcoule <> $iTempsEcoule
			_GUICtrlStatusBar_SetText($hStatusBar, "Temps coul : " & _HeureMinSec($iTempsEcoule), 1)
			$iOldTempsEcoule = $iTempsEcoule
	EndSelect
WEnd

_GUICtrlStatusBar_Destroy($hStatusBar)
GUIDelete($gui)


#Region MENUS
Func _Nouveau()
	If _VerifieParametres() = 0 Then Return 0
	_Attente(1)
	$iDebut = TimerInit()
	_ReInitVariables()
	_CreeLab3D()
	_RecreeGUI()
	_DessineLabyrinthe()
	_AfficheImage()
	_GUICtrlStatusBar_SetText($hStatusBar, "Labyrinthe gnr en " & Round(TimerDiff($iDebut) / 1000, 3) & " s")
	_Attente(0)
	$iDebut = TimerInit()
	Return 1
EndFunc   ;==>_Nouveau


Func _Charger()
	_ChargeLabyrinthe()
	If @error Then Return
	_Attente(1)
	_RecreeGUI()
	_DessineLabyrinthe()
	_GDIPlus_ImageDispose($hPerso)
	$hPerso = _ChargePersonnage()
	_AfficheImage()
	_Attente(0)
	$iDebut = TimerInit()
EndFunc   ;==>_Charger


Func _ChangerSkin()
	If _ChangeSkin() = 0 Then Return
	_Attente(1)
	_RecreeGUI()
	_DessineLabyrinthe()
	_GDIPlus_ImageDispose($hPerso)
	$hPerso = _ChargePersonnage()
	_AfficheImage()
	_Attente(0)
EndFunc   ;==>_ChangerSkin


Func _MeilleurScore()
	_AfficheScore()
	If MsgBox(260, "Labyrinthe", "Voulez vous quitter ?") = 6 Then Return 0
	If _Nouveau() = 0 Then Return 0
	$iVictoire = 0
	Return 1
EndFunc   ;==>_MeilleurScore


Func _VoirMeilleursScores()
	Local $a_scores, $sText
	$a_scores = _GetScores()
	
	If $a_scores = "" Then
		$sText = @CRLF & "Aucun score dans cette catgorie !"
	Else
		For $i = 0 To UBound($a_scores) - 1
			$sText &= @CRLF & $a_scores[$i][0] & " : " & _HeureMinSec($a_scores[$i][1])
			GUICtrlCreateLabel($a_scores[$i][0] & " : " & _HeureMinSec($a_scores[$i][1]), 20, 83 + 30 * $i)
		Next
	EndIf
	
	MsgBox(0, "", "Meilleurs scores de cette catgorie :" & @CRLF & $sText)
EndFunc   ;==>_VoirMeilleursScores
#EndRegion MENUS


Func _ReInitVariables()
	Dim $aObjets[1][4]
	$aPosition[0] = $aCoordEntree[0]
	$aPosition[1] = $aCoordEntree[1]
	$aPosition[2] = $iEtages - 1
EndFunc   ;==>_ReInitVariables


#Region GUIs
Func _ConstruitTray()
	Opt("TrayMenuMode", 1)
	$tiQuitter = TrayCreateItem("&Quitter")
	TrayCreateItem("", -1, -1)
	$tiNouveau = TrayCreateItem("Crer un &nouveau labyrinthe")
	$tiCharger = TrayCreateItem("&Ouvrir un labyrinthe")
	$tiEnregistrer = TrayCreateItem("&Sauvegarder la labyrinthe en cours")
	TrayCreateItem("", -1, -1)
	$tiSkin = TrayCreateItem("Modifier le &design")
EndFunc   ;==>_ConstruitTray


Func _RecreeGUI()
	Local $width = ($iLargeur + 2) * $iTailleCellule
	Local $WinWidth = $width + 6
	Local $height
	Switch $iEtages
		Case 1
			$height = ($iHauteur + 2) * $iTailleCellule
		Case Else
			$height = ($iHauteur + 3) * $iTailleCellule
	EndSwitch
	Local $WinHeight = $height + 75
	Local $aStatusParts[2] = [$width / 2, $width / 2]
	
	If IsHWnd($gui) Then
		WinMove($gui, "", (@DesktopWidth - $WinWidth) / 2, (@DesktopHeight - $WinHeight) / 2, $WinWidth, $WinHeight)
		_GUICtrlStatusBar_SetParts($hStatusBar, $aStatusParts)
		
		_GDIPlus_ImageDispose($hImage)
		_GDIPlus_GraphicsDispose($hGraphicWnd)
	Else
		$gui = GUICreate("Laby_Etages", $width, $height + 43)
		
		$mJeu = GUICtrlCreateMenu("&Jeu")
		$miNouveau = GUICtrlCreateMenuItem("Crer un &nouveau labyrinthe", $mJeu)
		$miCharger = GUICtrlCreateMenuItem("&Ouvrir un labyrinthe", $mJeu)
		$miEnregistrer = GUICtrlCreateMenuItem("&Sauvegarder la labyrinthe en cours", $mJeu)
		GUICtrlCreateMenuItem("", $mJeu, 3)
		$miScores = GUICtrlCreateMenuItem("&Meilleurs scores", $mJeu)
		
		$mOptions = GUICtrlCreateMenu("&Options")
		$miSkin = GUICtrlCreateMenuItem("Modifier le &design", $mOptions)
		
		$hStatusBar = _GUICtrlStatusBar_Create($gui, $aStatusParts)
		GUISetState()
	EndIf
	
	If $iTempsCreation > 0 Then $sStatusBarText = "Labyrinthe gnr en " & $iTempsCreation & " s"
	_GUICtrlStatusBar_SetText($hStatusBar, $sStatusBarText)
	
	_CreeImage($width, $height, $hImage, $hGraphicImage)
	$hGraphicWnd = _GDIPlus_GraphicsCreateFromHWND($gui)
EndFunc   ;==>_RecreeGUI


Func _ConstruitGUIAttente()
	$gui_attente = GUICreate("Labyrinthe", 200, 100, Default, Default, BitOR($WS_POPUPWINDOW, $WS_SYSMENU), $WS_EX_TOPMOST)
	GUISwitch($gui_attente)
	
	_CreeImage(200, 100, $hImageAttente, $hGraphicAttente)
	
	Local $hBrush, $hFamily, $hFont, $hLayout, $hStringFormat
	$hBrush = _GDIPlus_BrushCreateSolid($hexCouleurPolice)
	$hFamily = _GDIPlus_FontFamilyCreate($sPolice)
	$hFont = _GDIPlus_FontCreate($hFamily, 15, 3, 3)
	$hLayout = _GDIPlus_RectFCreate(10, 10, 180, 80)
	$hStringFormat = _GDIPlus_StringFormatCreate()
	_GDIPlus_StringFormatSetAlign($hStringFormat, 1)
	_GDIPlus_GraphicsDrawStringEx($hGraphicAttente, "Veuillez patienter...", $hFont, $hLayout, $hStringFormat, $hBrush)
	
	; Clean up resources
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hStringFormat)
	_GDIPlus_BrushDispose($hBrush)
EndFunc   ;==>_ConstruitGUIAttente


Func _Attente($iFlag)
	Switch $iFlag
		Case 1
			GUISetState(@SW_SHOW, $gui_attente)
			
			If Not IsHWnd($hGraphicWndAttente) Then $hGraphicWndAttente = _GDIPlus_GraphicsCreateFromHWND($gui_attente)
			_AfficheImage($gui_attente)
		Case 0
			GUISetState(@SW_HIDE, $gui_attente)
	EndSwitch
EndFunc   ;==>_Attente


Func _AfficheScore()
	Local $lab_score, $lab_categorie, $lab_pseudo, $inpt_pseudo, $but_valider, $but_annuler
	Local $iTime = Round(TimerDiff($iDebut) / 1000), $a_scores, $i
	
	$gui_score = GUICreate("Scores", 300, 270, Default, Default, Default, Default, $gui)
	GUISwitch($gui_score)
	
	$lab_score = GUICtrlCreateLabel("Vous avez gagn en " & _HeureMinSec($iTime) & " !", 20, 23)
	$lab_categorie = GUICtrlCreateLabel("Meilleurs scores de cette catgorie :", 20, 53)
	$a_scores = _GetScores()
	If $a_scores = "" Then
		GUICtrlCreateLabel("Aucun score dans cette catgorie !", 20, 83)
	Else
		For $i = 0 To UBound($a_scores) - 1
			GUICtrlCreateLabel($a_scores[$i][0] & " : " & _HeureMinSec($a_scores[$i][1]), 20, 83 + 30 * $i)
		Next
	EndIf
	
	$lab_pseudo = GUICtrlCreateLabel("Indiquez ici votre pseudo :", 20, 173)
	$inpt_pseudo = GUICtrlCreateInput("", 150, 170)
	$but_valider = GUICtrlCreateButton("Enregistrer", 40, 220, 100, 30)
	$but_annuler = GUICtrlCreateButton("Annuler", 160, 220, 100, 30)
	
	GUISetState()
	
	While 1
		$msg = GUIGetMsg()
		
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $but_annuler
				ExitLoop
			Case $msg = $but_valider
				If GUICtrlRead($inpt_pseudo) = "" Then
					MsgBox(16, "Erreur", "Vous devez indiquer un pseudo !")
				Else
					_EnregistreScore($iTime, GUICtrlRead($inpt_pseudo))
				EndIf
				ExitLoop
		EndSelect
	WEnd
	
	GUIDelete($gui_score)
EndFunc   ;==>_AfficheScore
#EndRegion GUIs


#Region FICHIER
Func _ChargeLabyrinthe()
	$pPath = FileOpenDialog("Choisissez un fichier de sauvegarde", "", "Fichiers Labyrinthe (*.lab)")
	If @error Then Return SetError(1, 0, 0)
	If StringRight($pPath, 4) <> ".lab" Then
		MsgBox(16, "Erreur", "Ce fichier ne contient pas un labyrinthe !")
		Return SetError(1, 0, 0)
	EndIf
	If Not FileExists($pPath) Then Return SetError(1, 0, 0)
	
	$sStatusBarText = StringTrimLeft($pPath, StringInStr($pPath, "\", 0, -1))
	
	Local $aArray, $aArray2, $i, $j, $k, $iChr
	
	$iLargeur = IniRead($pPath, "labyrinthe", "Largeur", "")
	$iHauteur = IniRead($pPath, "labyrinthe", "Hauteur", "")
	$iEtages = IniRead($pPath, "labyrinthe", "Etages", 1)
	$aArray = IniRead($pPath, "labyrinthe", "Entree", "")
	$aEntree = StringSplit($aArray, ";", 2)
	$aArray = IniRead($pPath, "labyrinthe", "Sortie", "")
	$aSortie = StringSplit($aArray, ";", 2)
	
	$aArray = IniRead($pPath, "labyrinthe", "Horizontaux", "")
	Dim $aMursHorizontaux[$iLargeur][$iHauteur - 1][$iEtages]
	$iChr = 1
	For $i = 0 To $iLargeur - 1
		For $j = 0 To $iHauteur - 2
			For $k = 0 To $iEtages - 1
				$aMursHorizontaux[$i][$j][$k] = StringMid($aArray, $iChr, 1)
				$iChr += 1
			Next
		Next
	Next
	
	$aArray = IniRead($pPath, "labyrinthe", "Verticaux", "")
	Dim $aMursVerticaux[$iLargeur - 1][$iHauteur][$iEtages]
	$iChr = 1
	For $i = 0 To $iLargeur - 2
		For $j = 0 To $iHauteur - 1
			For $k = 0 To $iEtages - 1
				$aMursVerticaux[$i][$j][$k] = StringMid($aArray, $iChr, 1)
				$iChr += 1
			Next
		Next
	Next
	
	$aArray = IniRead($pPath, "labyrinthe", "Objets", "")
	Select
		Case $aArray = ""
			Dim $aObjets[1][4]
		Case Else
			$aArray = StringSplit($aArray, "|")
			Dim $aObjets[$aArray[0]][4]
			For $i = 0 To $aArray[0] - 1
				$aArray2 = StringSplit($aArray[$i + 1], ";", 2)
				$aObjets[$i][0] = $aArray2[0]
				$aObjets[$i][1] = $aArray2[1]
				$aObjets[$i][2] = $aArray2[2]
				$aObjets[$i][3] = $aArray2[3]
			Next
	EndSelect
	
	$hexCouleurFond = IniRead($pPath, "skin", "ColFond", "")
	$hexCouleurMur = IniRead($pPath, "skin", "ColMurs", "")
	$iEpaisseurMur = IniRead($pPath, "skin", "EpMurs", "")
	$hexCouleurContour = IniRead($pPath, "skin", "ColContour", "")
	$iEpaisseurContour = IniRead($pPath, "skin", "EpContour", "")
	$iTailleCellule = IniRead($pPath, "skin", "TailleCellule", "")
	$sPolice = IniRead($pPath, "skin", "Police", "")
	$hexCouleurPolice = IniRead($pPath, "skin", "ColPolice", "")
	$pPerso = IniRead($pPath, "skin", "Perso", $pPerso)
	$pEscMontee = IniRead($pPath, "skin", "Montee", $pEscMontee)
	$pEscDescente = IniRead($pPath, "skin", "Descente", $pEscDescente)
	
	$hexCouleurMur = "0xFF" & StringRight($hexCouleurMur, 6)
	$hexCouleurContour = "0xFF" & StringRight($hexCouleurContour, 6)
	$hexCouleurFond = "0xFF" & StringRight($hexCouleurFond, 6)
	$hexCouleurPolice = "0xFF" & StringRight($hexCouleurPolice, 6)
	
	$aArray = IniRead($pPath, "joueur", "Pos", "")
	$aPosition = StringSplit($aArray, ";", 2)
	
	$iTempsCreation = 0
	
	Return SetError(0, 0, 1)
EndFunc   ;==>_ChargeLabyrinthe


Func _EnregistreLabyrinthe()
	$pPath = FileSaveDialog("Choisissez un fichier de sauvegarde", "", "Fichiers Labyrinthe (*.lab)")
	If @error Then Return
	If StringRight($pPath, 4) <> ".lab" Then
		MsgBox(16, "Erreur", "L'extension spcifie est incorrecte.")
		Return
	EndIf
	If FileExists($pPath) Then
		If MsgBox(4 + 256, "Labyrinthe", "Le fichier spcifi existe dj." & @CRLF & "Voulez-vous l'craser ?") <> 6 Then Return
	EndIf
	
	IniWrite($pPath, "labyrinthe", "Largeur", $iLargeur)
	IniWrite($pPath, "labyrinthe", "Hauteur", $iHauteur)
	IniWrite($pPath, "labyrinthe", "Etages", $iEtages)
	IniWrite($pPath, "labyrinthe", "Entree", $aEntree[0] & ";" & $aEntree[1])
	IniWrite($pPath, "labyrinthe", "Sortie", $aSortie[0] & ";" & $aSortie[1])
	
	Local $sHorizontaux, $sVerticaux, $sObjets, $i, $j, $k
	For $i = 0 To $iLargeur - 1
		For $j = 0 To $iHauteur - 2
			For $k = 0 To $iEtages - 1
				$sHorizontaux &= $aMursHorizontaux[$i][$j][$k]
			Next
		Next
	Next
	For $i = 0 To $iLargeur - 2
		For $j = 0 To $iHauteur - 1
			For $k = 0 To $iEtages - 1
				$sVerticaux &= $aMursVerticaux[$i][$j][$k]
			Next
		Next
	Next
	For $i = 0 To UBound($aObjets) - 1
		$sObjets &= $aObjets[$i][0] & ";"
		$sObjets &= $aObjets[$i][1] & ";"
		$sObjets &= $aObjets[$i][2] & ";"
		$sObjets &= $aObjets[$i][3]
		If $i < UBound($aObjets) - 1 Then $sObjets &= "|"
	Next
	IniWrite($pPath, "labyrinthe", "Horizontaux", $sHorizontaux)
	IniWrite($pPath, "labyrinthe", "Verticaux", $sVerticaux)
	IniWrite($pPath, "labyrinthe", "Objets", $sObjets)
	
	IniWrite($pPath, "skin", "ColFond", StringRight($hexCouleurFond, 6))
	IniWrite($pPath, "skin", "ColMurs", StringRight($hexCouleurMur, 6))
	IniWrite($pPath, "skin", "EpMurs", $iEpaisseurMur)
	IniWrite($pPath, "skin", "ColContour", StringRight($hexCouleurContour, 6))
	IniWrite($pPath, "skin", "EpContour", $iEpaisseurContour)
	IniWrite($pPath, "skin", "TailleCellule", $iTailleCellule)
	IniWrite($pPath, "skin", "Police", $sPolice)
	IniWrite($pPath, "skin", "ColPolice", StringRight($hexCouleurPolice, 6))
	IniWrite($pPath, "skin", "Perso", $pPerso)
	IniWrite($pPath, "skin", "Montee", $pEscMontee)
	IniWrite($pPath, "skin", "Descente", $pEscDescente)
	
	IniWrite($pPath, "joueur", "Pos", $aPosition[0] & ";" & $aPosition[1] & ";" & $aPosition[2])
EndFunc   ;==>_EnregistreLabyrinthe


Func _GetScores()
	Local $a_scores, $a_hi_scores[3][2], $i
	
	$a_scores = IniReadSection(@ScriptDir & "\scores.ini", $iLargeur & ":" & $iHauteur & ":" & $iEtages)
	If Not IsArray($a_scores) Then Return ""
	
	_ArraySort($a_scores, 0, 0, 0, 1)
	
	Dim $a_hi_scores[_Min($a_scores[0][0], 3)][2]
	For $i = 1 To _Min($a_scores[0][0], 3)
		$a_hi_scores[$i - 1][0] = $a_scores[$i][0]
		$a_hi_scores[$i - 1][1] = $a_scores[$i][1]
	Next
	
	Return $a_hi_scores
EndFunc   ;==>_GetScores


Func _EnregistreScore($iTime, $sPseudo)
	IniWrite(@ScriptDir & "\scores.ini", $iLargeur & ":" & $iHauteur & ":" & $iEtages, $sPseudo, $iTime)
EndFunc   ;==>_EnregistreScore


Func LitSkin($key)
	Local $val = IniRead(@ScriptDir & "\skins.ini", $skin, $key, "")
	If $val = "" Then $val = Default
	Return $val
EndFunc   ;==>LitSkin
#EndRegion FICHIER


#Region FONCTIONS DIVERSES
Func Quitter()
	Exit
EndFunc   ;==>Quitter


Func ExitFunc()
	GUIRegisterMsg(0xF, "")
	_DesactiveRaccourcis()

	_GDIPlus_ImageDispose($hImage)
	_GDIPlus_ImageDispose($hPerso)
	_GDIPlus_GraphicsDispose($hGraphicWnd)
	_GDIPlus_GraphicsDispose($hGraphicWndAttente)
	_GDIPlus_Shutdown()
EndFunc   ;==>ExitFunc


Func _GetCoord($aEntSort)
	Local $aCoord[2]
	
	Switch $aEntSort[0]
		Case 1
			$aCoord[0] = $aEntSort[1] - 1
			$aCoord[1] = 0
		Case 2
			$aCoord[0] = 0
			$aCoord[1] = $aEntSort[1] - 1
		Case 3
			$aCoord[0] = $iLargeur - 1
			$aCoord[1] = $aEntSort[1] - 1
		Case 4
			$aCoord[0] = $aEntSort[1] - 1
			$aCoord[1] = $iHauteur - 1
	EndSwitch
	
	Return $aCoord
EndFunc   ;==>_GetCoord


Func _HeureMinSec($iSec)
	If $iSec = 0 Then Return "0 secondes"
	
	Local $sTemps, $iHeures, $iMin
	$iHeures = Floor($iSec / 3600)
	$iSec -= $iHeures * 3600
	$iMin = Floor($iSec / 60)
	$iSec -= $iMin * 60
	If $iHeures = 1 Then $sTemps &= $iHeures & " heure "
	If $iHeures > 1 Then $sTemps &= $iHeures & " heures "
	If $iMin = 1 Then $sTemps &= $iMin & " minute "
	If $iMin > 1 Then $sTemps &= $iMin & " minutes "
	If $iSec = 1 Then $sTemps &= $iSec & " seconde"
	If $iSec > 1 Then $sTemps &= $iSec & " secondes"
	Return $sTemps
EndFunc   ;==>_HeureMinSec
#EndRegion FONCTIONS DIVERSES