Func _ChargeParametres()
	$iTailleCellule = LitSkin("TailleCellule")
	$hexCouleurMur = LitSkin("ColMurs")
	$iEpaisseurMur = LitSkin("EpMurs")
	$hexCouleurContour = LitSkin("ColContour")
	$iEpaisseurContour = LitSkin("EpContour")
	$hexCouleurFond = LitSkin("ColFond")
	$sPolice = LitSkin("Police")
	$hexCouleurPolice = LitSkin("ColPolice")
	$pPerso = _PathFull(LitSkin("Perso"))
	$pEscMontee = _PathFull(LitSkin("Montee"))
	$pEscDescente = _PathFull(LitSkin("Descente"))

	If $iTailleCellule = Default Then $iTailleCellule = 16
	If $hexCouleurMur = Default Then $hexCouleurMur = 0x000000
	If $iEpaisseurMur = Default Then $iEpaisseurMur = 2
	If $hexCouleurContour = Default Then $hexCouleurContour = 0x000000
	If $iEpaisseurContour = Default Then $iEpaisseurContour = 3
	If $hexCouleurFond = Default Then $hexCouleurFond = 0xFFFFFF
	If $sPolice = Default Then $sPolice = "Arial"
	If $hexCouleurPolice = Default Then $hexCouleurPolice = 0x000000
	If $pPerso = Default Then $pPerso = @ScriptDir & "\cercle.png"
	If $pEscMontee = Default Then $pEscMontee = @ScriptDir & "\monte.png"
	If $pEscDescente = Default Then $pEscDescente = @ScriptDir & "\descente.png"
	
	$hexCouleurMur = "0xFF" & String(Hex($hexCouleurMur, 6))
	$hexCouleurContour = "0xFF" & String(Hex($hexCouleurContour, 6))
	$hexCouleurFond = "0xFF" & String(Hex($hexCouleurFond, 6))
	$hexCouleurPolice = "0xFF" & String(Hex($hexCouleurPolice, 6))
EndFunc   ;==>_ChargeParametres


Func _VerifieParametres()
	Local $gui_param, $lab_larg, $inpt_larg, $ud_larg, $lab_haut, $inpt_haut, $ud_haut, $lab_etages, $inpt_etages, $ud_etages, $but_valid, $but_annul, $lab_dir_entree, $comb_dir_entree, $lab_pos_entree, $inpt_pos_entree, $ud_pos_entree, $lab_dir_sortie, $comb_dir_sortie, $lab_pos_sortie, $inpt_pos_sortie, $ud_pos_sortie, $lab_escaliers, $inpt_escaliers, $ud_escaliers
	
	$gui_param = GUICreate("Nouveau labyrinthe", 300, 340, Default, Default, Default, Default, $gui)
	GUISwitch($gui_param)
	
	; Largeur
	$lab_larg = GUICtrlCreateLabel("Largeur du labyrinthe :", 20, 23)
	$inpt_larg = GUICtrlCreateInput($iLargeur, 140, 20, 50, Default, $ES_READONLY)
	$ud_larg = GUICtrlCreateUpdown($inpt_larg)
	GUICtrlSetLimit($ud_larg, 50, 1)
	
	; Hauteur
	$lab_haut = GUICtrlCreateLabel("Hauteur du labyrinthe :", 20, 53)
	$inpt_haut = GUICtrlCreateInput($iHauteur, 140, 50, 50, Default, $ES_READONLY)
	$ud_haut = GUICtrlCreateUpdown($inpt_haut)
	GUICtrlSetLimit($ud_haut, 40, 1)
	
	; Etages
	$lab_etages = GUICtrlCreateLabel("Nombres d'tages :", 20, 83)
	$inpt_etages = GUICtrlCreateInput($iEtages, 140, 80, 50, Default, $ES_READONLY)
	$ud_etages = GUICtrlCreateUpdown($inpt_etages)
	GUICtrlSetLimit($ud_etages, 15, 1)
	
	; Escaliers
	$lab_escaliers = GUICtrlCreateLabel("Nombres d'escaliers :", 20, 113)
	$inpt_escaliers = GUICtrlCreateInput($iEscaliers, 140, 110, 50, Default, $ES_READONLY)
	$ud_escaliers = GUICtrlCreateUpdown($inpt_escaliers)
	GUICtrlSetLimit($ud_escaliers, 10, 1)
	
	; Entre
	$lab_dir_entree = GUICtrlCreateLabel("Mur d'entre :", 20, 153)
	$comb_dir_entree = GUICtrlCreateCombo("", 140, 150)
	GUICtrlSetData(-1, "haut|gauche|droite|bas", "haut")
	
	$lab_pos_entree = GUICtrlCreateLabel("Position sur le mur :", 20, 183)
	$inpt_pos_entree = GUICtrlCreateInput("1", 140, 180, 50, Default, $ES_READONLY)
	$ud_pos_entree = GUICtrlCreateUpdown($inpt_pos_entree)
	GUICtrlSetLimit($ud_pos_entree, $iLargeur, 1)
	
	; Sortie
	$lab_dir_sortie = GUICtrlCreateLabel("Mur de sortie :", 20, 223)
	$comb_dir_sortie = GUICtrlCreateCombo("", 140, 220)
	GUICtrlSetData(-1, "haut|gauche|droite|bas", "bas")
	
	$lab_pos_sortie = GUICtrlCreateLabel("Position sur le mur :", 20, 253)
	$inpt_pos_sortie = GUICtrlCreateInput($iLargeur, 140, 250, 50, Default, $ES_READONLY)
	$ud_pos_sortie = GUICtrlCreateUpdown($inpt_pos_sortie)
	GUICtrlSetLimit($ud_pos_sortie, $iLargeur, 1)
	
	; Boutons
	$but_valid = GUICtrlCreateButton("Valider", 30, 300, 100, 30)
	$but_annul = GUICtrlCreateButton("Annuler", 170, 300, 100, 30)
	
	GUISetState()
	
	Local $msg, $value, $value2, $iLargeurTmp, $iHauteurTmp
	While 1
		$msg = GUIGetMsg()
		$value = GUICtrlRead($comb_dir_entree)
		$value2 = GUICtrlRead($comb_dir_sortie)
		$iLargeurTmp = Number(GUICtrlRead($inpt_larg))
		$iHauteurTmp = Number(GUICtrlRead($inpt_haut))
		
		Select
			Case $msg = $GUI_EVENT_CLOSE Or $msg = $but_annul
				GUIDelete()
				Return 0
			Case $msg = $but_valid
				$iLargeur = $iLargeurTmp
				$iHauteur = $iHauteurTmp
				$iEtages = GUICtrlRead($inpt_etages)
				$iEscaliers = GUICtrlRead($inpt_escaliers)
				
				Dim $aEntree[2], $aSortie[2]
				$aEntree[0] = _ValeurCote($value)
				$aEntree[1] = Number(GUICtrlRead($inpt_pos_entree))
				$aSortie[0] = _ValeurCote($value2)
				$aSortie[1] = Number(GUICtrlRead($inpt_pos_sortie))
				$aCoordEntree = _GetCoord($aEntree)
				$aCoordSortie = _GetCoord($aSortie)
				
				GUIDelete()
				Return 1
				
				; Changement de largeur / hauteur => limitation des positions d'entre / sortie
			Case $msg = $ud_larg
				If $value = "haut" Or $value = "bas" Then
					GUICtrlSetLimit($ud_pos_entree, $iLargeurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_entree)) > $iLargeurTmp Then GUICtrlSetData($inpt_pos_entree, $iLargeurTmp)
				EndIf
				If $value2 = "haut" Or $value2 = "bas" Then
					GUICtrlSetLimit($ud_pos_sortie, $iLargeurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_sortie)) > $iLargeurTmp Then GUICtrlSetData($inpt_pos_sortie, $iLargeurTmp)
				EndIf
			Case $msg = $ud_haut
				If $value = "gauche" Or $value = "droite" Then
					GUICtrlSetLimit($ud_pos_entree, $iHauteurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_entree)) > $iHauteurTmp Then GUICtrlSetData($inpt_pos_entree, $iHauteurTmp)
				EndIf
				If $value2 = "gauche" Or $value2 = "droite" Then
					GUICtrlSetLimit($ud_pos_sortie, $iHauteurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_sortie)) > $iHauteurTmp Then GUICtrlSetData($inpt_pos_sortie, $iHauteurTmp)
				EndIf
				
				; Changement de mur => limitation des positions d'entre / sortie
			Case $msg = $comb_dir_entree
				If $value = "haut" Or $value = "bas" Then
					GUICtrlSetLimit($ud_pos_entree, $iLargeurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_entree)) > $iLargeurTmp Then GUICtrlSetData($inpt_pos_entree, $iLargeurTmp)
				Else
					GUICtrlSetLimit($ud_pos_entree, $iHauteurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_entree)) > $iHauteurTmp Then GUICtrlSetData($inpt_pos_entree, $iHauteurTmp)
				EndIf
			Case $msg = $comb_dir_sortie
				If $value2 = "haut" Or $value2 = "bas" Then
					GUICtrlSetLimit($comb_dir_sortie, $iLargeurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_sortie)) > $iLargeurTmp Then GUICtrlSetData($inpt_pos_sortie, $iLargeurTmp)
				Else
					GUICtrlSetLimit($comb_dir_sortie, $iHauteurTmp, 1)
					If Number(GUICtrlRead($inpt_pos_sortie)) > $iHauteurTmp Then GUICtrlSetData($inpt_pos_sortie, $iHauteurTmp)
				EndIf
				
				; Mur choisi inexistant
			Case $value <> "haut" And $value <> "gauche" And $value <> "droite" And $value <> "bas"
				GUICtrlSetData($comb_dir_entree, "")
				GUICtrlSetData($comb_dir_entree, "haut|gauche|droite|bas", "haut")
				MsgBox(48, "Attention", "Vous avez choisi une valeur inexistante !")
			Case $value2 <> "haut" And $value2 <> "gauche" And $value2 <> "droite" And $value2 <> "bas"
				GUICtrlSetData($comb_dir_sortie, "")
				GUICtrlSetData($comb_dir_sortie, "haut|gauche|droite|bas", "bas")
				MsgBox(48, "Attention", "Vous avez choisi une valeur inexistante !")
		EndSelect
	WEnd
EndFunc   ;==>_VerifieParametres


Func _ValeurCote($sCote)
	Switch $sCote
		Case "haut"
			Return 1
		Case "gauche"
			Return 2
		Case "droite"
			Return 3
		Case "bas"
			Return 4
	EndSwitch
EndFunc   ;==>_ValeurCote